<?php
/* PHP file: "gestioncommentaires-en.php"
+------------------------------------------------------------------------------+
| Extension for "add comments" functionnality                                  |
| Tedheu 2009, version 1.0 (en),        updated on november 09 2009            |
| PHP script module to handle comments capture and storage                     |
| run with the required  JavaScript module "commentaires.js"                   |
+------------------------------------------------------------------------------+
*/
/*========= Personalization parameters =======================================*/
// Each message have a parameter for validation (index 'v' of the $Message array)
// when its value is 0 the message is stored but will be not displayed
// when its value is 1 the message is stored and will be displayed
// with a value of -1 the message will be discarded from the file storage
$validmesdef= 1;  // default validation of the message
//
/*========= Variables (initialization) =======================================*/
$jeton= NULL;       // normally filled with GET variables
$sujet= NULL;       // normally filled with GET variables
$action= NULL;      // normally filled with GET variables
//---
$entetedef= '|=== comments file, T novembre 09, 2009 - version 1.0 ===|'."\n";
$nouveau= false;     // message not new by default
$imesnou= -1;        // new message index fixed at -1
//--- messages => array of arrays
// the visitor send a comment with other informations wich form a message
$Message= array();
$Message['*']= array(); // * > jeton
$Message['s']= array(); // s > sujet
$Message['v']= array(); // v > validation, -1, 0 or 1 , 0 > not valid, -1 > rejected
$Message['i']= array(); // i > IP number
$Message['d']= array(); // d > date of today
$Message['h']= array(); // h > hour
$Message['n']= array(); // n > nom
$Message['c']= array(); // c > comment
$Message['r']= array(); // r > reserved for future use
//--- two actions are possible: lecture, ecriture (read and write)
$Actionliste= array('lecture','ecriture');
//--- parameters for security processing
$tagspermis= '<b><i><u><a><br><small><img>';
$Evenements= array('onAbort','onBlur','onChange','onClick','onDbclick','onDragdrop','onError','onFocus','onKeydown','onKeypress','onKeyup','onLoad','onMouseOver','onMouseOut','onReset','onResize','onSelect','onSubmit','onUnload');
foreach ($Evenements as $evenement){$Clefs[]= '/'.$evenement.'/i';}
$Car_nr= array("\n\r","\r\n","\n","\r");
$Carspe= array('&','','','','','','','','','','');
array_push($Carspe,'','','','','','','','','','','','','','','','');
array_push($Carspe,'','','','','','','','','','','','');
array_push($Carspe,'','');
foreach ($Carspe as $car){$Carchgs[]= htmlentities($car);}
array_push($Carspe,'%','^');
array_push($Carchgs,'&#37;','&#94;');
//-----------------------------------------------------------------------------/
/*========= Informations retrieval ===========================================*/
//--- miscellaneous informations
$ipc=$_SERVER['REMOTE_ADDR']; // client IP number
$jour= date('d.m.Y');
$heure= date('H:i');
//--- parameters passed by GET method
(!empty($_GET['sujet']))? $sujet=$_GET['sujet']: $sujet='aucun';
(!empty($_GET['action']))? $action=$_GET['action']: $action='rien';
(!empty($_GET['jeton']))? $jeton= $_GET['jeton']: $jeton= '0';
//--- data processing on input GET data
$sujet= substr(strip_tags($sujet),0,30);
$sujet_r= substr(strip_tags($sujet),0,10);
if (!in_array($action,$Actionliste)) $action='rien';
$jeton= preg_replace('/[^0-9]/','',$jeton); // only numeral
$jeton= substr($jeton,0,10);
//-----------------------------------------------------------------------------/
/*========= Request validation ===============================================*/
$valide= true;
if ($sujet=='aucun') $valide= false;
if ($action=='rien') $valide= false;
if ($jeton=='0') $valide= false;
if (!$valide) {
    // the script will be stopped while the request is not valid
    exit;
}  
/*========= Create files if they don't exist yet =============================*/
$nomfichier_verrou= 'verrou_'.$sujet_r.'.txt';
$nomfichier_messag= 'messages_'.$sujet_r.'.txt';
if (!file_exists($nomfichier_verrou)) touch($nomfichier_verrou);
if (!file_exists($nomfichier_messag)){
    $pf0=fopen($nomfichier_messag,'w');
    fwrite($pf0,$entetedef);
    fclose($pf0);
}
//-----------------------------------------------------------------------------/
//
/*========= Write process ($action= 'ecriture') ==============================*/
if ($action=='ecriture'){
    $nouveau= true; // the message is supposed to be new
    //
    //=== parameters passed by POST method ------------------------------------/
    (!empty($_POST['nom']))? $nom= $_POST['nom']: $nom= 'inconnu';
    (!empty($_POST['message']))? $commentaire= $_POST['message']: $commentaire= '';
    //--- data processing on input POST data
    $nom= strip_tags($nom);
    $nom= str_replace($Car_nr,'',$nom);
    $nom= htmlentities(substr($nom,0,20));
    $commentaire= strip_tags($commentaire,$tagspermis);
    $commentaire= preg_replace($Clefs,'none',$commentaire);
    $commentaire= str_replace($Carspe,$Carchgs,$commentaire);
    $commentaire= str_replace($Car_nr,'<br>',$commentaire);
    $commentaire= preg_replace('/\\\/','',$commentaire);  // cancel backslash
    //-------------------------------------------------------------------------/
    //=== Read/Write messages file access -------------------------------------/
    //--- setting up of a lock -------------------------
    $deb= time(); $tempo= 2; $erreur= '';
    do{
        $verrou= file($nomfichier_verrou);
        if (count($verrou)==0) break;
    }while((time()-$deb)<=$tempo);
    if (count($verrou)!=0){ // (the lock is still held > time-out)
        $erreur.= '-- the lock is blocked --';
        if ((time()-trim($verrou[0]))>=10){
            $erreur.= ' & -- lock is released --';
            $pfv=fopen($nomfichier_verrou,'w');
            fwrite($pfv,'');
            fclose($pfv);
        }
    }
    else{  // (if no error the lock is set)
        $pfv=fopen($nomfichier_verrou,'w');
        fwrite($pfv,time());
        fclose($pfv);
    }
    if ($erreur!='') die('ERROR: '.$erreur);
    //-----------------------------------------------------
    //--- reading of the messages file, line by line
    $pf1= fopen($nomfichier_messag,'r');
    $n=-1;
    while (!feof($pf1)) $ligne[++$n]=fgets($pf1,1024);
    fclose($pf1);
    $nlgn= $n;
    //-------------------------------------------------------------------------/
    //=== file contents analysis and data processing --------------------------/
    $entete=$ligne[0]; // the fist line is an header
    $imesnou= 0; // the index of the new message = 0
    if ($nouveau){
        $Message['*'][0]= $jeton;
        $Message['s'][0]= $sujet;
        $Message['v'][0]= $validmesdef;
        $Message['i'][0]= $ipc;
        $Message['d'][0]= $jour;
        $Message['h'][0]= $heure;
        $Message['n'][0]= $nom;
        $Message['c'][0]= $commentaire;
        $Message['r'][0]= 'RFU';
    }
    //--- data processing line by line to extract the recorded messages
    $imes= 1;
    $jeton_tst= false; $ipc_tst= false; $heure_tst= false;
    for ($ilgn=1; $ilgn<=$nlgn; $ilgn++){
        $clef= substr($ligne[$ilgn],0,3);
        $contenu= str_replace($Car_nr,'',substr($ligne[$ilgn],3));
        switch($clef){
            case '\\*\\': // jeton
                $Message['*'][$imes]= $contenu;
                ($jeton==$contenu)? $jeton_tst= true: $jeton_tst= false; break;
            case '\\s\\':
                $Message['s'][$imes]= $contenu;
            case '\\v\\':
                $Message['v'][$imes]= $contenu;
            case '\\i\\':
                $Message['i'][$imes]= $contenu;
                ($ipc==$contenu)? $ipc_tst= true: $ipc_tst= false; break;
            case '\\d\\':
                $Message['d'][$imes]= $contenu;
                ($jour==$contenu)? $d_tst= true: $d_tst= false; break;
            case '\\h\\':
                $Message['h'][$imes]= $contenu;
                $mindif= substr($heure,3,4) - substr($contenu,3,4);
                ($mindif<=5)? $heure_tst= true: $heure_tst= false;
                $heudif= substr($heure,0,2) - substr($contenu,0,2);
                if ($heudif!=0) $heure_tst= false;
                break;
            case '\\n\\':
                $Message['n'][$imes]= $contenu; break;
            case '\\c\\':
                $Message['c'][$imes]= $contenu; break;
            case '\\r\\':
                $Message['r'][$imes]= $contenu; break;
            case '\\-\\':
                // end of message
                if ($nouveau AND $jeton_tst AND $ipc_tst AND $heure_tst){
                    // the current message and the new message are the same post
                    $imesnou= $imes; // index of the new message
                    $Message['h'][$imes]= $heure;
                    $Message['n'][$imes]= $nom;
                    $Message['c'][$imes]= $commentaire;
                }
                $imes++; // next message
                $jeton_tst= false; $ipc_tst= false; $heure_tst= false;
                break;
        }
    }
    $nmes= $imes-1;
    //--- the new message is discarded if its comment field is empty
    if ($commentaire==''){
        $Message['v'][$imesnou]= -1;
        $nouveau= 0;
    } 
    //-------------------------------------------------------------------------/
    //=== Messages file rewriting  --------------------------------------------/
    $pf2=fopen($nomfichier_messag,'w');
    fwrite($pf2,$entete);
    ($nouveau AND ($imesnou==0))? $imesdeb=0: $imesdeb=1;
    for ($imes=$imesdeb; $imes<=$nmes; $imes++){
        if ($Message['v'][$imes]== -1) continue; // '-1'> le message est effac
        fwrite($pf2,'\\*\\'.$Message['*'][$imes]."\n");
        fwrite($pf2,'\\s\\'.$Message['s'][$imes]."\n");
        fwrite($pf2,'\\v\\'.$Message['v'][$imes]."\n");
        fwrite($pf2,'\\i\\'.$Message['i'][$imes]."\n");
        fwrite($pf2,'\\d\\'.$Message['d'][$imes]."\n");
        fwrite($pf2,'\\h\\'.$Message['h'][$imes]."\n");
        fwrite($pf2,'\\n\\'.$Message['n'][$imes]."\n");
        fwrite($pf2,'\\c\\'.$Message['c'][$imes]."\n");
        fwrite($pf2,'\\r\\'.$Message['r'][$imes]."\n");
        fwrite($pf2,'\\-\\----------'."\n");
    }
    fclose($pf2);
    //-------------------------------------------------------------------------/
    //=== lock is released ----------------------------------------------------/
    $pfv=fopen($nomfichier_verrou,'w');
    fwrite($pfv,'');
    fclose($pfv);
    //-------------------------------------------------------------------------/
}// $action== 'ecriture'
//
/*========= Read process ($action= 'lecture') ================================*/
if ($action=='lecture'){
    $nouveau= false; // no new message
    //--- messages file reading, line by line
    $pf1= fopen($nomfichier_messag,'r');
    $n=-1;
    while (!feof($pf1)) $ligne[++$n]=fgets($pf1,1024);
    fclose($pf1);
    $nlgn= $n;
    //-------------------------------------------------------------------------/
    //=== contents analysis and data processing -------------------------------/
    $entete=$ligne[0]; // the first line is an header
    //--- data processing line by line
    $imes= 1;
    for ($ilgn=1; $ilgn<=$nlgn; $ilgn++){
        $clef= substr($ligne[$ilgn],0,3);
        $contenu= substr($ligne[$ilgn],3);
        $contenu= str_replace($Car_nr,'',$contenu);
        switch($clef){
            case '\\v\\':
                $Message['v'][$imes]= $contenu; break;
            case '\\d\\':
                $Message['d'][$imes]= $contenu; break;
            case '\\h\\':
                $Message['h'][$imes]= $contenu; break;
            case '\\n\\':
                $Message['n'][$imes]= $contenu; break;
            case '\\c\\':
                $Message['c'][$imes]= $contenu; break;
            case '\\-\\': // end of message
                $imes++;  // next
                break;
        }
    }
    $nmes= $imes-1;
}// $action== 'lecture'
//-----------------------------------------------------------------------------//

/*========= Displaying =======================================================*/
if ($nouveau){
$imes= $imesnou;
    echo('<hr><fieldset>');
    echo('<legend>Your new message is recorded :  <i>( ou can modified it again )</i></legend>');
    echo('&nbsp;Name: '.$Message['n'][$imes].'<br>');
    echo($Message['c'][$imes]);
    echo('</fieldset>');
}
//
echo('<hr>');
for ($imes=1; $imes<=$nmes; $imes++){
    if ($Message['v'][$imes]== 0) continue; // '0'> the message is not displayed
    if ($imes != $imesnou){
        echo('<b>Name&nbsp;:</b>&nbsp;'.$Message['n'][$imes].'&nbsp;&nbsp;');
        echo('<b>Date&nbsp:</b>&nbsp;'.$Message['d'][$imes].'&nbsp;'.$Message['h'][$imes].'<br>');
        echo($Message['c'][$imes].'<br>');
        echo('<hr>'."\n");
    }
}
//-----------------------------------------------------------------------------/
?>
